/***********************************************************************************************************************
 *
 * blueBill Resources - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it
 * SCM: https://java.net/hg/bluebill~resources-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.factsheet.wikipedia.photos;

import it.tidalwave.openrdf.elmo.impl.ElmoEntityFactory;
import it.tidalwave.semantic.EntityFactory;
import it.tidalwave.util.Id;
import javax.annotation.Nonnull;
import javax.xml.namespace.QName;
import org.openrdf.concepts.dc.DcResource;
import org.openrdf.concepts.skos.core.Concept;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class ElmoTaxonFactSheetFactory
  {
    protected final EntityFactory<TaxonFactSheet, ElmoTaxonFactSheet> factSheetFactory =
            new ElmoEntityFactory<TaxonFactSheet, ElmoTaxonFactSheet>(TaxonFactSheet.class,
                                                                      ElmoTaxonFactSheet.class,
                                                                      Concept.class,
                                                                      DcResource.class);

    @Nonnull
    public TaxonFactSheet createTaxonFactSheet (final @Nonnull Id id)
      {
        return factSheetFactory.create(new QName(id.stringValue()));
      }
  }
