/***********************************************************************************************************************
 *
 * blueBill Resources - open source birding
 * Copyright (C) 2009-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluebill.tidalwave.it
 * SCM: https://java.net/hg/bluebill~resources-src
 *
 **********************************************************************************************************************/
package it.tidalwave.bluebill.factsheet.wikipedia.photos;

import javax.annotation.Nonnull;
import java.io.File;
import it.tidalwave.bluebill.taxonomy.birds.BirdTaxonomyImporter;
import it.tidalwave.bluebill.taxonomy.birds.GeneratorSupport;

/***********************************************************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
public class WikipediaPhotosGenerator extends GeneratorSupport
  {
    public static final String TAXONOMY_NAME = "CatalogueOfLife";
    public static final String TAXONOMY_FILE_NAME = "WikipediaPhotos";

    private final WikipediaPhotosImporter importer;

    public static void main (final @Nonnull String ... args)
      throws Exception
      {
        new WikipediaPhotosGenerator(args[0], new WikipediaPhotosImporter(), TAXONOMY_FILE_NAME).execute();
      }

    public WikipediaPhotosGenerator (final @Nonnull String baseDir, 
                                     final @Nonnull WikipediaPhotosImporter importer,
                                     final @Nonnull String fileName)
      {
        super(baseDir, TAXONOMY_NAME, fileName);
        this.importer = importer;
      }

    @Nonnull
    public BirdTaxonomyImporter run()
      throws Exception
      {
        importer.setIdentifierMapFile(new File(resourcesFolder, "TaxonIdMap.txt.gz"));
        importer.run(repository, taxonomyName);

        return importer;
      }
  }
